version: '3'
services:

  ###> OPENAPI ###
  swagger-editor:
    image: swaggerapi/swagger-editor
    ports:
      - "19000:8080"
    networks:
      - ex-book-list-api-go
  swagger-ui:
    image: swaggerapi/swagger-ui
    volumes:
      - ./public/v1:/swagger
    environment:
      SWAGGER_JSON: /swagger/openapi.json
    ports:
      - "19010:8080"
    networks:
      - ex-book-list-api-go
  ###< OPENAPI  ###

  ###> EX-BOOK-LIST-API ###
  ex-book-list-api-go-db:
    image: postgres:14-alpine
    ports:
      - "45433:5432"
    volumes:
      - 'ex-book-list-api-go-db-data:/var/lib/postgresql/data'
    environment:
      - POSTGRES_PASSWORD=2vQU45haQCnDS8sO
      - POSTGRES_USER=ex-book-list-api-go
      - POSTGRES_DB=ex-book-list-api-go
    networks:
      - ex-book-list-api-go
  ex-book-list-api-go:
    build:
      context: .
      dockerfile: multi-stage.Dockerfile
    command: ["serve", "--config", "/secrets/local.env.yaml", "-b", "0.0.0.0", "-p", "8080", "-m", "-w", "10", "-l", "-c"]
    ports:
      - "8882:8080"
    volumes:
      - ./secrets/docker.env.yaml:/secrets/local.env.yaml
    depends_on:
      - ex-book-list-api-go-db
    networks:
      - ex-book-list-api-go
  ###< EX-BOOK-LIST-API ###

networks:
  ex-book-list-api-go:
    driver: bridge

volumes:
  data-volume:
  ex-book-list-api-go-db-data:
    driver: local
